from PIL import Image
import os
import configparser

CONFIG = configparser.ConfigParser()
CONFIG.read('../config.ini')


def concat_images():
    if not os.path.exists(CONFIG['pictures']['concatenate_img1']):
        print("Subor nebol najdeny")
    elif not os.path.exists(CONFIG['pictures']['concatenate_img2']):
        print("Subor nebol najdeny")
    else:
        im1 = Image.open(CONFIG['pictures']['concatenate_img1'])
        im2 = Image.open(CONFIG['pictures']['concatenate_img2'])

        new_image = Image.new('RGB', (im1.width + im2.width + 10, im1.height))
        new_image.paste(im1, (0, 0))
        new_image.paste(im2, (im1.width + 10, 0))

        file_name = CONFIG['pictures']['concatenate_dir'] + CONFIG['pictures']['concatenate_img1'].split('/')[4] + "-" + \
                    CONFIG['pictures']['concatenate_img2'].split('/')[4] + "/" + \
                    CONFIG['pictures']['concatenate_img1'].split('/')[5].split(".")[0] + "-" + \
                    CONFIG['pictures']['concatenate_img2'].split('/')[5].split(".")[0] + ".png"

        new_image.save(file_name)


if __name__ == "__main__":
    if not os.path.exists(CONFIG['pictures']['concatenate_dir']):
        os.makedirs(CONFIG['pictures']['concatenate_dir'])

    for class1 in CONFIG['pictures']['classes'].split(','):
        for class2 in CONFIG['pictures']['classes'].split(','):
            if not os.path.exists(CONFIG['pictures']['concatenate_dir'] + class1 + "-" + class2 + "/"):
                os.makedirs(CONFIG['pictures']['concatenate_dir'] + class1 + "-" + class2 + "/")

    concat_images()
