import pandas as pd
import os
import FeatureSelection.add_feature as add_feature
import configparser

CONFIG = configparser.ConfigParser()
CONFIG.read('../config.ini')

DF_FILE = CONFIG['create_features']['input_file']
DF_FEATURES_FILE = CONFIG['create_features']['features_file']

FEATURES_TO_CHECK = ['std_v_287', 'std_v_288', 'std_v_289', 'std_v_290', 'std_v_291', 'std_v_292', 'std_v_293',
                     'std_v_294', 'std_v_295', 'std_v_296', 'std_v_297', 'std_v_298', 'std_v_299', 'std_v_300',
                     'std_v_301', 'std_v_302', 'std_v_303', 'std_v_304', 'std_v_305', 'std_v_306', 'std_v_307',
                     'std_v_308', 'std_v_309', 'std_v_310', 'std_v_311', 'std_v_312', 'std_v_313', 'std_v_314',
                     'std_v_315', 'std_v_316', 'std_v_317', 'std_v_318', 'std_v_319', 'std_v_320', 'std_v_321',
                     'std_v_322', 'std_v_323', 'std_v_324', 'std_v_325', 'std_v_326', 'std_v_327', 'std_v_328',
                     'std_v_329', 'std_v_330', 'std_v_331', 'std_v_332', 'std_v_333', 'std_v_334', 'std_v_335',
                     'std_v_336', 'std_v_337', 'std_v_408', 'delta_v_189', 'delta_v_252', 'delta_v_329', 'delta_v_404',
                     'delta_v_405', 'delta_v_406', 'delta_v_407', 'delta_v_408', 'delta_v_409', 'delta_v_410',
                     'delta_v_411', 'delta_v_412', 'delta_v_413', 'delta_v_414', 'delta_v_415', 'delta_v_416',
                     'delta_v_417', 'delta_v_418', 'delta_v_419', 'delta_v_420', 'delta_v_421', 'delta_v_422',
                     'delta_v_423', 'delta_v_424', 'delta_v_425', 'delta_v_426', 'delta_v_427', 'delta_v_428',
                     'delta_v_429', 'delta_v_430', 'delta_v_431', 'delta_v_432', 'delta_v_433', 'delta_v_434',
                     'delta_v_435', 'delta_v_436', 'delta_v_437', 'delta_v_438', 'delta_v_439', 'delta_v_440',
                     'delta_v_441', 'delta_v_442', 'delta_v_443', 'delta_v_444', 'delta_v_445', 'delta_v_446',
                     'delta_v_447', 'sum_v_0', 'sum_v_151', 'sum_v_152', 'point_mean_201-10-1389-51',
                     'point_mean_201-43-1547-275', 'point_mean_202-7-2414-43', 'point_mean_206-1-3457-3',
                     'point_mean_204-2-3461-11', 'point_mean_201-9-3499-108', 'point_mean_201-146-3686-124',
                     'point_mean_203-4-4869-25', 'point_mean_207-2-5033-17', 'point_mean_207-1-5052-4',
                     'point_mean_201-10-5381-320', 'point_mean_201-10-1554-237', 'point_mean_201-9-3528-49',
                     'point_mean_201-147-3686-138', 'point_mean_207-2-4878-9', 'point_mean_207-2-5094-7',
                     'point_mean_201-10-5390-324', 'point_mean_202-3-1400-10', 'point_mean_201-7-1622-32',
                     'point_mean_203-6-1666-94', 'point_mean_207-1-1775-6', 'point_mean_207-2-1793-19',
                     'point_mean_202-2-5084-11', 'point_mean_201-8-5621-48', 'point_max_201-10-1389-51',
                     'point_max_201-43-1547-275', 'point_max_202-7-2414-43', 'point_max_206-1-3457-3',
                     'point_max_204-2-3461-11', 'point_max_201-9-3499-108', 'point_max_201-146-3686-124',
                     'point_max_203-4-4869-25', 'point_max_207-2-5033-17', 'point_max_207-1-5052-4',
                     'point_max_201-10-5381-320', 'point_max_201-10-1554-237', 'point_max_201-9-3528-49',
                     'point_max_201-147-3686-138', 'point_max_207-2-4878-9', 'point_max_207-2-5094-7',
                     'point_max_201-10-5390-324', 'point_max_202-3-1400-10', 'point_max_201-7-1622-32',
                     'point_max_203-6-1666-94', 'point_max_207-1-1775-6', 'point_max_207-2-1793-19',
                     'point_max_202-2-5084-11', 'point_max_201-8-5621-48', 'diff_EVOO', 'diff_VOO', 'diff_LOO',
                     'diff_EVOO-mask', 'diff_VOO-mask', 'diff_LOO-mask']


def create_features_df(df):
    df_features = df.iloc[:, : 2]
    df_features = df_features.drop_duplicates()
    df_features = df_features.reset_index(drop=True)
    return df_features


def create_features(df):
    df_features = create_features_df(df)
    add_feature.check_missing(df, FEATURES_TO_CHECK, df_features)
    return df_features


if __name__ == "__main__":
    if os.path.exists(CONFIG['create_features']['input_file']):
        df = pd.read_csv(CONFIG['create_features']['input_file'], header=0)
        # df_features = create_features(df)
        if os.path.exists(CONFIG['create_features']['features_file']):
            df_features = pd.read_csv(CONFIG['create_features']['features_file'], header=0)
        else:
            df_features = create_features_df(df)
        add_feature.check_missing(df, FEATURES_TO_CHECK, df_features)
    else:
        print("DATA file does not exist")
