from Predprocessing.convert_functions import *
import os
import configparser

CONFIG = configparser.ConfigParser()
CONFIG.read('../config.ini')

NUMBER_OF_EVOO = int(CONFIG['convert']['NUMBER_OF_EVOO'])
NUMBER_OF_VOO = int(CONFIG['convert']['NUMBER_OF_VOO'])
NUMBER_OF_LOO = int(CONFIG['convert']['NUMBER_OF_LOO'])
SAVE_PATH = CONFIG['convert']['output_file']
LOAD_PATH_EVOO = CONFIG['convert']['EVOO_path']
LOAD_PATH_VOO = CONFIG['convert']['VOO_path']
LOAD_PATH_LOO = CONFIG['convert']['LOO_path']


def convert_multiple_oils(path, limit_sample, oil_type, output):
    i = 0
    files = os.listdir(path)
    for file_name in files:
        file_path = path + "/" + file_name + "/Spectra.POSITIVE.txt"
        if i == limit_sample:
            break
        i += 1
        print(i, file_path)
        head = oil_type + "," + file_name
        convert_oil(file_path, output, head)


if __name__ == "__main__":
    out = open(CONFIG['convert']['output_file'], "w")
    print_header(out)

    convert_multiple_oils(CONFIG['convert']['EVOO_path'], int(CONFIG['convert']['NUMBER_OF_EVOO']), "EVOO", out)
    convert_multiple_oils(CONFIG['convert']['VOO_path'], int(CONFIG['convert']['NUMBER_OF_VOO']), "VOO", out)
    convert_multiple_oils(CONFIG['convert']['LOO_path'], int(CONFIG['convert']['NUMBER_OF_LOO']), "LOO", out)
