import pandas as pd
import configparser
import os

CONFIG = configparser.ConfigParser()
CONFIG.read('../config.ini')

LOAD_PATH = CONFIG['filter_values']['input_file']
SAVE_PATH = CONFIG['filter_values']['output_file']


def filter_values_1_150(data):
    columns = data.columns
    if "v_1" not in data.columns:
        print("Error: column " + "v_1" + " not found")
        return None
    if "v_150" not in data.columns:
        print("Error: column " + "v_150" + " not found")
        return None
    start_value = columns.get_loc("v_1")
    end_value = columns.get_loc("v_150") + 1        # +1 to be included
    data = data.drop(columns=columns[start_value:end_value])
    return data


def filter_values_last(data):
    columns = data.columns
    data = data.drop(columns=columns[-1])
    return data


if __name__ == "__main__":
    df = pd.read_csv(CONFIG['filter_values']['input_file'], low_memory=False)
    df = filter_values_1_150(df)
    df = filter_values_last(df)
    df.to_csv(CONFIG['filter_values']['output_file'], index=False, float_format='%.3f')
