import numpy as np
import pandas as pd
from joblib import dump
from datetime import datetime
from Neurons.train_mlp import train_mlp
from StandardClasification.decision_tree import train_decision_tree
from StandardClasification.knn import train_knn
from StandardClasification.naive_bayes import train_naive_bayes
from StandardClasification.random_forest import train_random_forest
from StandardClasification.svm import train_svm


def train_model(classifier, train_features, train_labels):

    if classifier == 'random_forest':
        clf = train_random_forest(train_features, train_labels)
    elif classifier == 'decision_tree':
        clf = train_decision_tree(train_features, train_labels)
    elif classifier == 'knn':
        clf = train_knn(train_features, train_labels)
    elif classifier == 'naive_bayes':
        clf = train_naive_bayes(train_features, train_labels)
    elif classifier == 'svm':
        clf = train_svm(train_features, train_labels)
    elif classifier == 'mlp':
        clf = train_mlp(train_features, train_labels)
    else:
        print("Error: column " + str(classifier) + " not found")
        return None

    clf.fit(train_features, train_labels)

    timestamp = str(datetime.now()).replace(":", "-")
    timestamp = timestamp.split(".")[0]
    name = str(classifier) + "-" + timestamp + '.joblib'
    path = '../Models/StandardClasification/' + name

    dump(clf, path)
    print(clf.get_params())

    return clf


# function for retraining the model in the app
def retrain_model():
    pass


def train(classifiers, data):
    train_labels = np.array(data['class'])
    data = data.drop('class', axis=1)
    data = data.drop('oil_id', axis=1)
    train_features = np.array(data)

    for i in range(len(classifiers)):
        classifier = classifiers[i]
        clf = train_model(classifier, train_features, train_labels)


if __name__ == "__main__":
    # Training
    data = pd.read_csv('../Data/Train/Feature/featuresTrain.csv')
    classifiers = ['decision_tree']
    train(classifiers, data)
