from sklearn import metrics
import seaborn as sns
import matplotlib.pyplot as plt
import os


def evaluate_clf(test_labels, pred_labels, name):
    # evaluation

    macro = metrics.f1_score(test_labels, pred_labels, average='macro')
    micro = metrics.f1_score(test_labels, pred_labels, average='micro')
    accuracy = metrics.accuracy_score(test_labels, pred_labels)

    print('accuracy', accuracy)
    print('macro', macro)
    print('micro', micro)

    cf_matrix = metrics.confusion_matrix(test_labels, pred_labels)
    print(cf_matrix)

    sns_plot = sns.heatmap(cf_matrix, annot=True)
    plt.savefig(os.path.join('../Statistic/charts/', name + "_matrix.png"))
    plt.clf()

    return [accuracy * 100, micro * 100, macro * 100]
