import pandas as pd
import sys
import math

sys.path.insert(1, '../Predprocessing/')
import check_missing_spectra


class TestMissingSpectra:
    def test_missing_spectra_class(self):
        df = pd.DataFrame({"class": ['evoo', 'evoo', 'loo', 'loo', 'voo', 'voo'], "oil_id": [1, 1, 2, 2, 3, 3],
                           "spectrum": [1, 2, 1, 2, 1, 2], "analysis_time": [0.13, 0.39, 0.13, 0.26, 0.26, 0.39]})
        new_df = check_missing_spectra.add_missing_spectra(df)
        assert math.isnan(new_df['class'][1]) is True

    def test_missing_spectra_spectrum(self):
        df = pd.DataFrame({"class": ['evoo', 'evoo', 'loo', 'loo', 'voo', 'voo'], "oil_id": [1, 1, 2, 2, 3, 3],
                           "spectrum": [1, 2, 1, 2, 1, 2], "analysis_time": [0.13, 0.39, 0.13, 0.26, 0.26, 0.39]})
        new_df = check_missing_spectra.add_missing_spectra(df)
        assert new_df['spectrum'][2] == 3

    def test_missing_spectra_time(self):
        df = pd.DataFrame({"class": ['evoo', 'evoo', 'loo', 'loo', 'voo', 'voo'], "oil_id": [1, 1, 2, 2, 3, 3],
                           "spectrum": [1, 2, 1, 2, 1, 2], "analysis_time": [0.13, 0.39, 0.13, 0.26, 0.26, 0.39]})
        new_df = check_missing_spectra.add_missing_spectra(df)
        assert new_df['analysis_time'][1] == 0.26
