import pandas as pd
import math
import sys
sys.path.insert(1, '../Predprocessing/')
import filter_values


class TestFilterValues:
    def test_filter_values_1_150(self):
        d = {'v_0': [1, 4], 'v_1': [4, 7], 'v_2': [1, 4], 'v_3': [4, 7], 'v_150': [1, 4], 'v_151': [4, 7]}
        df = pd.DataFrame(data=d)
        d = {'v_0': [1, 4], 'v_151': [4, 7]}
        result = pd.DataFrame(data=d)
        value = filter_values.filter_values_1_150(df)
        assert (result == value).values.all()

    def test_filter_values_1_150_missing_column(self):
        d = {'v_0': [1, 4], 'v_2': [1, 4], 'v_3': [4, 7], 'v_150': [1, 4], 'v_151': [4, 7]}
        df = pd.DataFrame(data=d)
        value = filter_values.filter_values_1_150(df)
        assert value is None

    def test_filter_values_1_150_missing_column2(self):
        d = {'v_0': [1, 4], 'v_1': [4, 7], 'v_2': [1, 4], 'v_3': [4, 7], 'v_151': [4, 7]}
        df = pd.DataFrame(data=d)
        value = filter_values.filter_values_1_150(df)
        assert value is None

    def test_filter_values_last(self):
        d = {'v_0': [1, 4], 'v_1': [4, 7], 'v_2': [1, 4], 'v_3': [4, 7], 'v_150': [1, 4], 'v_151': [4, 7]}
        df = pd.DataFrame(data=d)
        d = {'v_0': [1, 4], 'v_1': [4, 7], 'v_2': [1, 4], 'v_3': [4, 7], 'v_150': [1, 4]}
        result = pd.DataFrame(data=d)
        value = filter_values.filter_values_last(df)
        assert (result == value).values.all()
